#ifndef VOXBLOX_IO_LAYER_IO_INL_H_
#define VOXBLOX_IO_LAYER_IO_INL_H_

#include <fstream>
#include <string>

#include "voxblox/msgs/voxblox_msgs.h"

namespace voxblox {
namespace io {

// template <typename VoxelType>
// bool LoadBlocksFromFile(
//     const std::string& file_path,
//     typename Layer<VoxelType>::BlockMergingStrategy strategy,
//     bool multiple_layer_support, Layer<VoxelType>* layer_ptr) {
//   if(layer_ptr == nullptr){
//     throw std::exception("layer_ptr is null");
//   }
//   if(file_path.empty()){
//     throw std::exception("file path is empty");
//   }

//   // Open and check the file
//   std::fstream proto_file;
//   proto_file.open(file_path, std::fstream::in);
//   if (!proto_file.is_open()) {
//     std::cerr << "Could not open protobuf file to load layer: " << file_path;
//     return false;
//   }

//   // Byte offset result, used to keep track where we are in the file if
//   // necessary.
//   uint64_t tmp_byte_offset = 0;

//   bool layer_found = false;

//   do {
//     // Get number of messages
//     uint32_t num_protos;
//     if (!utils::readProtoMsgCountFromStream(&proto_file, &num_protos,
//                                             &tmp_byte_offset)) {
//       std::cerr << "Could not read number of messages.";
//       return false;
//     }

//     if (num_protos == 0u) {
//       std::cerr << "Empty protobuf file!";
//       return false;
//     }

//     // Get header and check if it is compatible with existing layer.
//     LayerProto layer_proto;
//     if (!utils::readProtoMsgFromStream(&proto_file, &layer_proto,
//                                        &tmp_byte_offset)) {
//       std::cerr << "Could not read layer protobuf message.";
//       return false;
//     }

//     if (layer_ptr->isCompatible(layer_proto)) {
//       layer_found = true;
//     } else if (!multiple_layer_support) {
//       std::cerr
//           << "The layer information read from file is not compatible with "
//              "the current layer!";
//       return false;
//     } else {
//       // Figure out how much offset to jump forward by. This is the number of
//       // blocks * the block size... Actually maybe we just read them in? This
//       // is probably easiest. Then if there's corrupted blocks, we abort.
//       // We just don't add these to the layer.
//       const size_t num_blocks = num_protos - 1;
//       for (uint32_t block_idx = 0u; block_idx < num_blocks; ++block_idx) {
//         BlockProto block_proto;
//         if (!utils::readProtoMsgFromStream(&proto_file, &block_proto,
//                                            &tmp_byte_offset)) {
//           std::cerr << "Could not read block protobuf message number "
//                      << block_idx;
//           return false;
//         }
//       }
//       continue;
//     }

//     // Read all blocks and add them to the layer.
//     const size_t num_blocks = num_protos - 1;
//     if (!LoadBlocksFromStream(num_blocks, strategy, &proto_file, layer_ptr,
//                               &tmp_byte_offset)) {
//       return false;
//     }
//   } while (multiple_layer_support && !layer_found && !proto_file.eof());
//   return layer_found;
// }

// template <typename VoxelType>
// bool LoadBlocksFromFile(
//     const std::string& file_path,
//     typename Layer<VoxelType>::BlockMergingStrategy strategy,
//     Layer<VoxelType>* layer_ptr) {
//   constexpr bool multiple_layer_support = false;
//   return LoadBlocksFromFile(file_path, strategy, multiple_layer_support,
//                             layer_ptr);
// }

// template <typename VoxelType>
// bool LoadBlocksFromStream(
//     const size_t num_blocks,
//     typename Layer<VoxelType>::BlockMergingStrategy strategy,
//     std::istream* proto_file_ptr, Layer<VoxelType>* layer_ptr,
//     uint64_t* tmp_byte_offset_ptr) {
//   if(proto_file_ptr == null){
//     std::cerr << "proto file ptr is a nullptr" << std::endl;
//     exit(-1);
//   }
//   if(layer_ptr == nullptr){
//     std::cerr << "layer_ptr is a nullptr" << std::endl;
//     exit(-1);
//   }
//   if(tmp_byte_offset_ptr == nullptr){
//     std::cerr << "tmp_byte_offset is a nullptr" << std::endl;
//     exit(-1);
//   }
//   // Read all blocks and add them to the layer.
//   for (uint32_t block_idx = 0u; block_idx < num_blocks; ++block_idx) {
//     BlockProto block_proto;
//     if (!utils::readProtoMsgFromStream(proto_file_ptr, &block_proto,
//                                        tmp_byte_offset_ptr)) {
//       std::cerr << "Could not read block protobuf message number "
//                  << block_idx;
//       return false;
//     }

//     if (!layer_ptr->addBlockFromProto(block_proto, strategy)) {
//       std::cerr << "Could not add the block protobuf message to the layer!";
//       return false;
//     }
//   }
//   return true;
// }

// template <typename VoxelType>
// bool LoadLayer(const std::string& file_path, const bool multiple_layer_support,
//                typename Layer<VoxelType>::Ptr* layer_ptr) {
//   if(layer_ptr == nullptr){
//     std::cerr << "layer_ptr is a nullptr" << std::endl;
//     exit(-1);
//   }
//   if(file_path.empty()){
//     std::cerr << "file path is empty" << std::endl;
//     exit(-1);
//   }

//   // Open and check the file
//   std::fstream proto_file;
//   proto_file.open(file_path, std::fstream::in);
//   if (!proto_file.is_open()) {
//     std::cerr << "Could not open protobuf file to load layer: " << file_path;
//     return false;
//   }

//   // Byte offset result, used to keep track where we are in the file if
//   // necessary.
//   uint64_t tmp_byte_offset = 0;

//   bool layer_found = false;

//   do {
//     // Get number of messages
//     uint32_t num_protos;
//     if (!utils::readProtoMsgCountFromStream(&proto_file, &num_protos,
//                                             &tmp_byte_offset)) {
//       std::cerr << "Could not read number of messages.";
//       return false;
//     }

//     if (num_protos == 0u) {
//       std::cerr << "Empty protobuf file!";
//       return false;
//     }

//     // Get header and check if it is compatible with existing layer.
//     LayerProto layer_proto;
//     if (!utils::readProtoMsgFromStream(&proto_file, &layer_proto,
//                                        &tmp_byte_offset)) {
//       std::cerr << "Could not read layer protobuf message.";
//       return false;
//     }

//     if ((layer_proto.voxel_size() <= 0.0f) ||
//         (layer_proto.voxels_per_side() == 0u)) {
//       std::cerr
//           << "Invalid parameter in layer protobuf message. Check the format.";
//       return false;
//     }

//     if (getVoxelType<VoxelType>().compare(layer_proto.type()) == 0) {
//       layer_found = true;
//     } else if (!multiple_layer_support) {
//       std::cerr
//           << "The layer information read from file is not compatible with "
//              "the current layer!";
//       return false;
//     } else {
//       // Figure out how much offset to jump forward by. This is the number of
//       // blocks * the block size... Actually maybe we just read them in? This
//       // is probably easiest. Then if there's corrupted blocks, we abort.
//       // We just don't add these to the layer.
//       const size_t num_blocks = num_protos - 1;
//       for (uint32_t block_idx = 0u; block_idx < num_blocks; ++block_idx) {
//         BlockProto block_proto;
//         if (!utils::readProtoMsgFromStream(&proto_file, &block_proto,
//                                            &tmp_byte_offset)) {
//           std::cerr << "Could not read block protobuf message number "
//                      << block_idx;
//           return false;
//         }
//       }
//       continue;
//     }

//     *layer_ptr = aligned_shared<Layer<VoxelType> >(layer_proto);
//     if(*layer_ptr == NULL){
//       std::cerr << "layer_ptr is null" << std::endl;
//       exit(-1);
//     }

//     // Read all blocks and add them to the layer.
//     const size_t num_blocks = num_protos - 1;
//     if (!LoadBlocksFromStream(
//             num_blocks, Layer<VoxelType>::BlockMergingStrategy::kProhibit,
//             &proto_file, (*layer_ptr).get(), &tmp_byte_offset)) {
//       return false;
//     }
//   } while (multiple_layer_support && !layer_found && !proto_file.eof());
//   return layer_found;
// }

// // By default loads without multiple layer support (i.e., only checks the first
// // layer in the file).
// template <typename VoxelType>
// bool LoadLayer(const std::string& file_path,
//                typename Layer<VoxelType>::Ptr* layer_ptr) {
//   constexpr bool multiple_layer_support = false;
//   return LoadLayer<VoxelType>(file_path, multiple_layer_support, layer_ptr);
// }

// template <typename VoxelType>
// bool SaveLayer(const Layer<VoxelType>& layer, std::string file_path,
//                bool clear_file) {
//   if(file_path.empty()){
//     std::cerr << "file path is empty" << std::endl;
//     exit(-1);
//   }
//   return layer.saveToFile(file_path, clear_file);
// }

// template <typename VoxelType>
// bool SaveLayerSubset(const Layer<VoxelType>& layer,
//                      const std::string& file_path,
//                      const BlockIndexList& blocks_to_include,
//                      bool include_all_blocks) {
//   if(file_path.empty()){
//     std::cerr << "file path is empty" << std::endl;
//     exit(-1);
//   }
//   return layer.saveSubsetToFile(file_path, blocks_to_include,
//                                 include_all_blocks);
// }

}  // namespace io
}  // namespace voxblox

#endif  // VOXBLOX_IO_LAYER_IO_INL_H_
